//////////////////////////////////////////////////////////////////////////////
//Copyright (C) 2011-12 Christos Christodoulopoulos and Tejaswini Deoskar

//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 3 of the License, or (at your option) any later version.

//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package edinburgh.ccg.parse;

import edinburgh.ccg.probModel.util.BinaryNode;
import edinburgh.ccg.probModel.util.BinaryTree;

public class BinaryDerivation extends Derivation {	
	public BinaryDerivation(String res, BinaryTree leftT, Cell c1Cell, 
			BinaryTree rightT, Cell c2Cell, String exp, double derivScore,
			String modelKey){
		result = res;
		score = derivScore;
		leftTree = leftT;
		leftCatCell = c1Cell;
		rightTree = rightT;
		rightCatCell = c2Cell;
		expansion = exp;
		resultTree = new BinaryNode(result, expansion);
		if (exp.equals(BinaryTree.leftHeadExp)){
			((BinaryNode) resultTree).setHead(leftTree);
			((BinaryNode) resultTree).setSister(rightTree);
		}
		else {
			((BinaryNode) resultTree).setHead(rightTree);
			((BinaryNode) resultTree).setSister(leftTree);
		}
		modelDependentKey = modelKey;
	}

	/** 
	 * The toString() function is now used just for the LaTex printing.
	 */
	public String toString(){
		return modelDependentKey;
	}

	public boolean isBinary(){
		return true;
	}
	public boolean isUnary(){
		return false;

	}
	public boolean isTerminal(){
		return false;
	}
}
