//////////////////////////////////////////////////////////////////////////////
//Copyright (C) 2011-12 Christos Christodoulopoulos and Tejaswini Deoskar

//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 3 of the License, or (at your option) any later version.

//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package edinburgh.ccg.parse;

import edinburgh.ccg.probModel.util.BinaryLeaf;
import edinburgh.ccg.probModel.util.BinaryTree;

public class TerminalDerivation extends Derivation{
	
	public TerminalDerivation(String word, String tag, String res, double derivScore, int index){
		result = res;
		score = derivScore;
		expansion = BinaryTree.leafExp;
		this.word = word;
		resultTree = new BinaryLeaf(result, word, tag, index);
	}

	public String toString(){
		return result+"|"+word ;
	}

	public boolean isBinary(){
		return false;
	}
	public boolean isUnary(){
		return false;

	}
	public boolean isTerminal(){
		return true;

	}
}
