//////////////////////////////////////////////////////////////////////////////
//Copyright (C) 2011-12 Christos Christodoulopoulos and Tejaswini Deoskar

//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.

//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

package edinburgh.ccg.probModel.util;

import java.util.ArrayList;
import java.util.List;

public class PargStructure {

	private String sisterWord;
	private List<Integer> headInds;
	private List<String> headWords;
	private List<String> headCats;
	private int size;
	
	public PargStructure(String sW){
		sisterWord = sW;
		headInds = new ArrayList<Integer>(1);
		headWords = new ArrayList<String>(1);
		headCats = new ArrayList<String>(1);
		size = 0;
	}
	
	public void addHead(int headIndex, String headWord, String headCat){
		headInds.add(headIndex);
		headCats.add(headCat);
		headWords.add(headWord);
		size++;
	}
	
	public int size(){
		return size;
	}
	
	public String toString(int index){
		String headW = headWords.get(index);
		String headC = headCats.get(index);
		int headI = headInds.get(index);
		return headI+"\t"+headC+"\t"+"XX"+"\t"+sisterWord+" "+headW;
	}
}
